#include "prefix.h"
#include "zero.h"

#if DBG
char printk_buf[1024];
#endif

KDriver *Driver;

NTSTATUS
KDriver::Entry(
    IN PDRIVER_OBJECT DriverObject,
    IN PUNICODE_STRING RegistryPath
    )
{
 KdBreakPoint();

 printk("Entry()\n");
 
 DriverObject->DriverUnload=Unload;
 libcpp_init();

 Driver=new (NonPagedPool) KDriver(DriverObject);

 if(!Driver)
  return STATUS_INSUFFICIENT_RESOURCES;

 return Driver->ConstructorStatus;
}

void KDriver::Unload(IN PDRIVER_OBJECT DriverObject)
{
// KdBreakPoint();
 printk("Unload()\n");

 delete Driver;
 libcpp_exit();
}

KDriver::KDriver(PDRIVER_OBJECT SysDo) : Device(0)
{
 DriverObject=SysDo;
/*
 DriverObject->MajorFunction[IRP_MJ_CREATE] = (PDRIVER_DISPATCH)KDevice::Dispatch;
 DriverObject->MajorFunction[IRP_MJ_CLOSE]  = (PDRIVER_DISPATCH)KDevice::Dispatch;
 DriverObject->MajorFunction[IRP_MJ_READ]   = (PDRIVER_DISPATCH)KDevice::Dispatch;
 DriverObject->MajorFunction[IRP_MJ_WRITE]  = (PDRIVER_DISPATCH)KDevice::Dispatch;
*/
 int i;
 for(i=0;i<IRP_MJ_MAXIMUM_FUNCTION;i++)
 {
  DriverObject->MajorFunction[i]  = (PDRIVER_DISPATCH)KDevice::Dispatch;
 }

 PFAST_IO_DISPATCH FastIoDispatch;
 FastIoDispatch = new(NonPagedPool) FAST_IO_DISPATCH;

 if(!FastIoDispatch) 
 {
  ConstructorStatus=STATUS_INSUFFICIENT_RESOURCES;
  return;
 }

 RtlZeroMemory(FastIoDispatch, sizeof(FAST_IO_DISPATCH));
 FastIoDispatch->SizeOfFastIoDispatch = sizeof(FAST_IO_DISPATCH);
 FastIoDispatch->FastIoRead   = KDevice::FastIoRead;
 FastIoDispatch->FastIoWrite  = KDevice::FastIoWrite;
 DriverObject->FastIoDispatch = FastIoDispatch;
 
 Device=new(DriverObject, L"\\Device\\zero", L"\\DosDevices\\zero") KDevice();
 if(Device)
  ConstructorStatus=Device->ConstructorStatus;
 else
  ConstructorStatus=STATUS_INSUFFICIENT_RESOURCES;
}
